﻿$engine JScript
$uname CodeAnalysis
$dname Анализ кода
$addin global
$addin stdlib

stdlib.require('TextWindow.js', SelfScript);
stdlib.require('SettingsManagement.js', SelfScript);
stdlib.require('SyntaxAnalysis.js', SelfScript);
stdlib.require(stdlib.getSnegopatMainFolder() + 'scripts\\epf\\epfloader.js', SelfScript);
global.connectGlobals(SelfScript);
var module = "";

function getCodeAnalysis(){

if (!CodeAnalysis._instance)
        new CodeAnalysis();
    
    return CodeAnalysis._instance;
 }

function CodeAnalysis(){
	CodeAnalysis._instance = this;
	var pathToForm=SelfScript.fullPath.replace(/.js$/, '.ssf')
	this.targetWindow = GetTextWindow();
	this.form = loadScriptForm(pathToForm, this)
	this.form.КлючСохраненияПоложенияОкна = SelfScript.uniqueName;
	this.watcher = new TextWindowsWatcher();
	this.epfLoaderParsingForm = EpfLoader.getEpf("ПарсингВнутреннегоПредставленияФормы");
	this.epfLoaderDupSearch = EpfLoader.getEpf("ПоискДубликатовКода");
	this.module = null;
}

SelfScript.self['macrosОткрыть окно'] = function() 
{	
	ca = getCodeAnalysis();
	ca.targetWindow = GetTextWindow();
	ca.update();
    ca.form.Open();
	
}

CodeAnalysis.prototype.CheckWindow = function () 
{
	if(!this.targetWindow || !this.targetWindow.IsActive())
		this.targetWindow = GetTextWindow();
		
	if(!this.targetWindow || !this.targetWindow.IsActive())
	{
		Message("Не найдено активное текстовое окно!");
		return false;
	}
    var Text = this.targetWindow.GetText();
    if (!Text) 
		return false;
	
	return true;
}

CodeAnalysis.prototype.update = function () 
{
	if(!this.CheckWindow())
		return;
		
	module = SyntaxAnalysis.AnalyseTextDocument(this.targetWindow);
	this.module = module;
	this.form.ДеревоАнализаДанных.Строки.Очистить();
	this.form.Controls.ДеревоАнализаДанных.Колонки.Параметр3.Видимость = false;
	
	////////////////////////////////////////////////
	// И так, начнем проверки...
	//debugger
	this.CheckMethodsSize(module);
	this.CheckParamsCount(module);	
	this.CheckStringSize(module);
	this.CheckOperatorsCount(module);
	this.CheckDeadMethods(module);
	this.CheckDeadVars(module);
	this.CheckSimilarVars(module);
}

CodeAnalysis.prototype.КоманднаяПанель1Обновить = function (Кнопка) 
{
	this.update()	
}

CodeAnalysis.prototype.ПолучитьСписокПовторов = function (ТекущаяСтрока)
{
	var СписокПовторов = v8new("СписокЗначений");
	// this.targetWindow.getText(ТекущаяСтрока.НомерСтроки + ТекущаяСтрока)
	// this.module.textWindow.;
	
	return СписокПовторов;
}

CodeAnalysis.prototype.ДеревоАнализаДанныхВыбор = function (Элемент, ВыбраннаяСтрока, Колонка, СтандартнаяОбработка) 
{
	switch (Колонка.val.Имя)
	{
		case "Справка":
			this.openHelp(ВыбраннаяСтрока.val.Справка);
			break;
		case "Параметр1":
			if(!ВыбраннаяСтрока.val.Параметр2)
				return;
			var МассивСтрок = ВыбраннаяСтрока.val.Параметр2.split(",");
			СписокСтрок = v8New("СписокЗначений");
			for(var i=0;i<МассивСтрок.length; i++)
				СписокСтрок.Добавить(МассивСтрок[i]);
			// if(ВыбраннаяСтрока.val.Параметр2.Количество() == 0)
				// ВыбраннаяСтрока.val.Параметр2 = this.ПолучитьСписокПовторов(ВыбраннаяСтрока.val);
			ВыбранныйЭлемент = this.form.ВыбратьИзСписка(СписокСтрок);
			if(ВыбранныйЭлемент != undefined)
			{
				Позиция_ = ВыбранныйЭлемент.Значение.indexOf("_");
				СтрокаНач = ВыбранныйЭлемент.Значение.substr(0, Позиция_);
				СтрокаКон = ВыбранныйЭлемент.Значение.substr(Позиция_ + 1);
				+СтрокаНач;
				+СтрокаКон;
				var str = {НомерСтроки: СтрокаНач, ВидПроблемы: ВыбраннаяСтрока.val.ВидПроблемы, СтрокаКон: СтрокаКон};
				this.goToLine(str);
				break;
			}
			break;
		default:
			this.goToLine(ВыбраннаяСтрока.val);		
	}
}

CodeAnalysis.prototype.activateEditor = function () {
	
	if (this.targetWindow){
    var activeView = this.targetWindow.GetView() ;
    if (activeView)
        activeView.activate();}
}

CodeAnalysis.prototype.openHelp = function (Справка) {
	
	if (!Справка)
		return;
	if(Справка.indexOf("http:")>=0)
		ЗапуститьПриложение(Справка)
	else
		Message(Справка)
}

CodeAnalysis.prototype.ДеревоАнализаДанныхПриВыводеСтроки = function (Элемент, ОформлениеСтроки, ДанныеСтроки)
{
	if(ДанныеСтроки.val.Родитель == undefined)
		ОформлениеСтроки.val.Шрифт = v8New("Шрифт", ОформлениеСтроки.val.Шрифт,undefined, undefined, true);
	
}

function AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка)
{
	var СтрокаМетодов = ДеревоАнализаДанных.Строки.Найти(ВидПроблемы, "ВидПроблемы");
	if(СтрокаМетодов == undefined)
	{
		СтрокаМетодов = ДеревоАнализаДанных.Строки.Добавить();
		СтрокаМетодов.ВидПроблемы = ВидПроблемы;
		СтрокаМетодов.Параметр1   = Параметр1;
		СтрокаМетодов.Справка     = Справка;
	}
	СтрокаМетодов.Строки.Очистить();
	
	return СтрокаМетодов;
}

function SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, Колонка)
{
	if(СтрокаВидПроблемы.Строки.Количество()==0)
		ДеревоАнализаДанных.Строки.Удалить(СтрокаВидПроблемы)
	else
		СтрокаВидПроблемы.Строки.Сортировать(Колонка)
}

function isCalls(Method, module, СписокСобытий, СтрокаОбработчиков)
{
	re = getRegExpVarEx(Method.Name);	
	if((Matches = re.exec(СтрокаОбработчиков)) != null)
		return true
	
	// Проверим событие это или нет
	for(j=0;j<СписокСобытий.length;j++)
	{
		if(Method.Name.indexOf(СписокСобытий[j])>=0)
			return true;
	}
	
	methodSource = module.getMethodSource(Method.Name);
	if(methodSource.match(/(?:Функция|Процедура)\s*\S*\(.*\)\s(Экспорт)/ig))
		return true
	if(methodSource.match(/Процедура\s*.*\(Команда\)/ig))
		return true
		
	mMethods = module.context.Methods;
	for(j=0;j<mMethods.length;j++)
	{
		curMethod = mMethods[j];
		try
		{
			for(k=0;k<curMethod.Calls.length;k++)
			{
				curcall = curMethod.Calls[k];
				if(curcall.indexOf(Method.Name)>=0)
					return true;
			}
		}
		catch(e){}
	}
	return false;
}

function СоставитьСписокОбработчиковСобытий() 
{
        var Список = [];
        Список.push("АвтоПодборТекста");
        Список.push("ВнешнееСобытие");
        Список.push("Выбор");
        Список.push("ВыборЗначения");
		Список.push("ДействияФормы");
		Список.push("КоманднаяПанель");
        Список.push("Нажатие");
        Список.push("НачалоВыбора");
        Список.push("НачалоВыбораИзСписка");
        Список.push("НачалоПеретаскивания");
        Список.push("ОбновлениеОтображения");
        Список.push("ОбработкаАктивизации");
        Список.push("ОбработкаВыбора");
        Список.push("ОбработкаЗаписиНовогоОбъекта");
		Список.push("ОбработкаЗаполнения");
        Список.push("ОбработкаОповещения");
		Список.push("ОбработкаПроведения");
		Список.push("ОбработкаПроверкиЗаполнения");
		Список.push("ОбработкаУдаленияПроведения");
		Список.push("ОбработкаПолученияДанныхВыбора");
		Список.push("ОбработкаПолученияФормы");
        Список.push("ОкончаниеВводаТекста");
        Список.push("ОкончаниеПеретаскивания");
        Список.push("Открытие");
        Список.push("Очистка");
        Список.push("ПередЗакрытием");
		Список.push("ПередЗаписью");
        Список.push("ПередНачаломДобавления");
        Список.push("ПередНачаломИзменения");
        Список.push("ПередОкончаниемРедактирования");
        Список.push("ПередОткрытием");
        Список.push("ПередУдалением");
        Список.push("Перетаскивание");
        Список.push("ПослеУдаления");
        Список.push("ПриАктивизации");
        Список.push("ПриАктивизацииКолонки");
        Список.push("ПриАктивизацииСтроки");
        Список.push("ПриАктивизацииЯчейки");
        Список.push("ПриВыводеСтроки");
		Список.push("ПриВыводеПериода");
        Список.push("ПриЗакрытии");
		Список.push("ПриЗаписи");
        Список.push("ПриИзменении");
        Список.push("ПриИзмененииФлажка");
		Список.push("ПриКомпоновкеРезультата");
		Список.push("ПриКопировании");
        Список.push("ПриНачалеРедактирования");
        Список.push("ПриОкончанииРедактирования");
        Список.push("ПриОткрытии");
        Список.push("ПриПовторномОткрытии");
        Список.push("ПриПолученииДанных");
        Список.push("ПриСменеСтраницы");
        Список.push("ПриСменеТекущегоРодителя");
		Список.push("ПриСозданииНаСервере");
		Список.push("ПриУстановкеНовогоКода");
		Список.push("ПриУстановкеНовогоНомера");
        Список.push("ПроверкаПеретаскивания");
        Список.push("ПередИзменениемРодителя");
        Список.push("ПередРазворачиванием");
        Список.push("ПередСворачиванием");
        Список.push("ПередУстановкойПометкиУдаления");
        Список.push("Регулирование");
		
        return Список;
}

function getRegExpVar(curVar)
{
		curVar.replace(/\\/g, "\\");
		curVar.replace(/\./g, "\.");
		curVar.replace(/\(/g, "\(");
		curVar.replace(/\)/g, "\)");
		curVar.replace(/\+/g, "\+");
		curVar.replace(/\*/g, "\*");
		curVar.replace(/\?/g, "\?");
		curVar.replace(/\^/g, "\^");
		curVar.replace(/\[/g, "\[");
		curVar.replace(/\]/g, "\]");
		
	try{return new RegExp("[\\,(\\[\\s=\\+\\-\\/\\*]" + curVar + "(?![\\wА-Яа-я\"])", 'ig')}
	catch(e){return new RegExp("NEVERFIND", '')}
}

function getRegExpVarEx(curVar)
{
	return new RegExp("\\s" + curVar + ",", 'ig');
}

function getRegExpVarCount(curVar)
{
	return new RegExp("(для|for)\\s" + curVar + "\\s?=", 'ig');
}

function ПолучитьПотокФормы(mdObj)
{	
	ПотокФормы = "";
	mOK = true;
	try{mdForm = mdObj.container.rootObject.childObject("Формы", mdObj.name)} catch(e){mOK = false}
	if(!mOK)
		try{mdForm = mdObj.parent.childObject("Формы", mdObj.name)} catch(e){return ПотокФормы}
	
	if(!mdForm)
		{}
	else
		{				
			ПотокФормы = tov8Value(mdForm.getExtProp("Форма").getForm()).toStringInternal();
			
			if(ПотокФормы == '{"U"}') //Если это управляемая форма, то поток бы получить не удалось
			{
				var extProp = mdForm.getExtProp("Форма");
				// Сохраним текущее состояние свойства "Форма" в файл. Так как файл в saveToFile не передан, то
				// сохранение произойдет в псевдо-файл в памяти.
				var file = extProp.saveToFile()
				try{
					// создадим хранилище на базе файла. Для управляемых форм тут вывалится в catch
					var stg = v8Files.attachStorage(file)
					// Получим из хранилища содержимое под-файла form
					var form = extProp.getForm();
				}catch(e)
				{
					file.seek(0, fsBegin)
					ПотокФормы = file.getString(dsUtf8);
				}
				
			}
		}

	return ПотокФормы;
}

function ПолучитьСтрокуИмен(mdObj, reexp)
{
	var СтрокаИмен = "";
	
		if(!mdObj)
			return СтрокаИмен;
	ПотокФормы = ПолучитьПотокФормы(mdObj);
	var re = new RegExp(reexp,'ig');
	while((Matches = re.exec(ПотокФормы)) != null)
	{
		СтрокаИмен = СтрокаИмен + " " + Matches[1] + ",";
	}
	/* reexp = '\\w{8}-\\w{4}-\\w{4}-\\w{4}-\\w{12}}*,\"([\\wА-Яа-я\\w]+)\"}*';
	var re = new RegExp(reexp,'ig');
	while((Matches = re.exec(ПотокФормы)) != null)
	{
			СтрокаИмен = СтрокаИмен + " " + Matches[1] + ",";
	}
		}
		
	} */	
	return СтрокаИмен;
}

CodeAnalysis.prototype.ПолучитьСтрокуОбработчиков = function (mdObj)
{	
	// Каждый из методов возвращает только часть обработчиков, поэтому используем оба, чтобы наверняка
	// 1.
	var СтрокаОбработчиков = ПолучитьСтрокуИмен(mdObj, '{[0-9]+,(?:\\w{8}-\\w{4}-\\w{4}-\\w{4}-\\w{12},[0-9]*,*)+\\n{[0-9]+,\"(.*)\",')	
	
	// 2.
	try{ФормаОбработки = this.epfLoaderParsingForm.ПолучитьФорму("Форма")}
	catch(e){Massage("Не удалось загрузить обработку ПарсингВнутреннегоПредставленияФормы из папки \scripts\epf"); return СтрокаОбработчиков}
	
	var ПотокФормы = ПолучитьПотокФормы(mdObj);
	if(!ПотокФормы)
		return СтрокаОбработчиков;
		
	ФормаОбработки.Текст1С = ПотокФормы;
	ТЗОбработчиков = ФормаОбработки.ПолучитьДанныеФормы();
	for(i=0;i<ТЗОбработчиков.Количество();i++)
	{
		ТекСтрока = ТЗОбработчиков.Получить(i);
		if(!ТекСтрока.Действие)
			continue;
		СтрокаОбработчиков = СтрокаОбработчиков + " " + ТекСтрока.Действие + ",";
	}
	
	return СтрокаОбработчиков;
	
}

function ПолучитьСтрокуРеквизитовФормы(mdObj)
{
	return ПолучитьСтрокуИмен(mdObj, '{[0-9]+},[0-9],[0-9],[0-9],\\"(.*)\\",')
}

function ПолучитьСтрокуРеквизитовОбъекта(mdObj)
{
	var СтрокаРеквизитов = "";
	
	if(!mdObj)
		return СтрокаРеквизитов;
		
	if(mdObj.parent == mdObj.container.rootObject && !(mdObj.mdclass.name(1,false).indexOf("Форма")+1))
		var mMO = mdObj;
	else
		var mMO = mdObj.parent;
	
	for(i=0;i<mMO.childObjectsCount("Реквизиты");i++)
	{
		СтрокаРеквизитов = СтрокаРеквизитов + " " + mMO.childObject("Реквизиты", i).name + ",";
	}
	
	return СтрокаРеквизитов;
}

function ИсключенияПеременных(mdObj)
{
	var СтрокаИсключений = "";	
	СтрокаИсключений = СтрокаИсключений + ПолучитьСтрокуРеквизитовФормы(mdObj);
	СтрокаИсключений = СтрокаИсключений + " Кнопка, Элемент, Команда, Отказ, СтандартнаяОбработка,"; 
	СтрокаИсключений = СтрокаИсключений + ПолучитьСтрокуРеквизитовОбъекта(mdObj);
	
	return СтрокаИсключений;
}

function ДобавитьДеревоВСтроку(Строки, ТекСтрокаДерева)
{
	for(var i=0; i < Строки.Количество(); i++)
	{
		Строка = Строки.Получить(i);
		НоваяСтрока = ТекСтрокаДерева.Строки.Добавить();
		НоваяСтрока.ВидПроблемы = Строка.Блок;
		НоваяСтрока.Параметр1 = Строка.Количество
		НоваяСтрока.НомерСтроки = Строка.СтрокаНач;
		// var СписокПовторов = v8New("СписокЗначений");
		// for(var j=0; j < Строка.Таблица.Количество();j++)
		// {
			// var ТекЭлемент = Строка.Таблица.Получить(j);
			// СписокПовторов.Добавить(ТекЭлемент.Значение, ТекЭлемент.Представление);
		// }
		НоваяСтрока.Параметр2 = Строка.Таблица;
		НоваяСтрока.Параметр3 = Строка.Размер;
		ДобавитьДеревоВСтроку(Строка.Строки, НоваяСтрока)
		НоваяСтрока.Строки.Сортировать("Параметр3");
	}
}

function clock() {
var d = new Date();
var hours = d.getHours();
var minutes = d.getMinutes();
var seconds = d.getSeconds();

if (hours <= 9) hours = "0" + hours;
if (minutes <= 9) minutes = "0" + minutes;
if (seconds <= 9) seconds = "0" + seconds;

date_time = ""+ hours + ":" + minutes + ":" + seconds;
return date_time;
}

CodeAnalysis.prototype.КоманднаяПанель1ДублированиеКода = function (Кнопка) 
{
	if(!this.CheckWindow())
		return;	
	var LinesCount = this.targetWindow.LinesCount()
	if(LinesCount > 1000) 
		Message("Начало проверки дублирования кода " + clock());
	this.CheckDuplicates(this.module)
	if(LinesCount > 1000)
		Message("Окончание " + clock());
}

CodeAnalysis.prototype.CheckDuplicates = function (module) 
{
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Дублирование кода";
	var Параметр1   = "Количество повторов";
	var Справка     = "http://refactoring.guru/smells/duplicate-code";
	
	this.form.Controls.ДеревоАнализаДанных.Колонки.Параметр3.Видимость = true;
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	СтрокаВидПроблемы.Параметр3 = "Размер";
	try
	{
		var ДеревоРезультатов = this.epfLoaderDupSearch.ВыполнитьПроверку(module.textWindow.GetText(), DupBlockMin, DupBlockMax);
		ДобавитьДеревоВСтроку(ДеревоРезультатов.Строки, СтрокаВидПроблемы);
	}
	
	catch(e){Massage("Не удалось загрузить обработку ПоискДубликатовКода из папки \scripts\epf")}
	
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр3 Убыв, Параметр1 Убыв, НомерСтроки");
}

function isWordSimilar(original, similarword, WholeWord)
{
	var нрИсходноеСлово = original.toLowerCase();
	var нрПохожееСлово  = similarword.toLowerCase();
	
	if (нрИсходноеСлово == нрПохожееСлово)
		return true;
	if(WholeWord)
		 if(нрПохожееСлово.indexOf(нрИсходноеСлово)>=0 || нрИсходноеСлово.indexOf(нрПохожееСлово)>=0) 
			 return false; //похожая, но все-таки другая
	if(нрИсходноеСлово.length > 7 || нрПохожееСлово.length > 7)		
		if(Math.abs(нрПохожееСлово.length - нрИсходноеСлово.length) > 2) 
			return false; //слишком разные по длине
	

		var ВсегоСовпадений = 0;		
		for(var i=0; i<нрПохожееСлово.length;i++)
		{
			Символ = нрПохожееСлово.charAt(i);
			if(i<нрПохожееСлово.length-1)
				Символ = Символ + нрПохожееСлово.charAt(i+1);
			Группа = (нрИсходноеСлово.substr(Math.max(1, i-1), i+2));
			
			if(Группа.indexOf(Символ) >= 0)
			ВсегоСовпадений = ВсегоСовпадений + 1;			
		}
	
	if(ВсегоСовпадений >= (нрИсходноеСлово.length / 5 * 3))
		return true;
	else
		return false;
}

function isVarSimilar(original, similarword)
{
	var нрИсходноеСлово = original.toLowerCase();
	var нрПохожееСлово  = similarword.toLowerCase();
	if(нрПохожееСлово.indexOf(нрИсходноеСлово)>=0 || нрИсходноеСлово.indexOf(нрПохожееСлово)>=0) 
		return false;
		
	var arroriginal = [];
	var arrsimilar  = [];
	
	re = new RegExp('([a-z,а-я]*[A-Z,А-Я,0-9]{1}[a-z,а-я,0-9]*)','g');
	while((Match = re.exec(original)) !=null)
		arroriginal.push(Match[1]);
	while((Match = re.exec(similarword)) !=null)
		arrsimilar.push(Match[1]);
	if(arroriginal.length == arrsimilar.length && arroriginal.length == 0)
		return isWordSimilar(original, similarword, true);
	if(arroriginal.length == arrsimilar.length && arroriginal.length > 0)
	{
		var issimilar = true;
		for(var i=0;i<arrsimilar.length;i++)
			issimilar = issimilar && isWordSimilar(arroriginal[i], arrsimilar[i],arroriginal.length == 1);
		return issimilar;
	}
	else
	{
		var issimilar = 0;
		var maxcount = Math.max(arrsimilar.length, arroriginal.length);
		for(var i=0;i<maxcount;i++)
		{
			if(i>=arroriginal.length) continue
			if(i>=arrsimilar.length) continue
			issimilar = issimilar + isWordSimilar(arroriginal[i], arrsimilar[i],false);
		}
		return Math.abs(issimilar - maxcount) <= 1 && maxcount > 1;	
	}
}

function ПолучитьСписокВсехПеременных(module)
{

	moduleVars = module.context.ModuleVars;
	
	ТабПеременных = v8New("ТаблицаЗначений");
	ТабПеременных.Колонки.Добавить("Имя");
	ТабПеременных.Колонки.Добавить("Метод");
	
	moduleText = module.textWindow.GetText();
	moduleVars = module.context.ModuleVars;
	Lines = module.textWindow.GetLines();
	for(i=0;i<moduleVars.length;i++)
	{
		var curVar = moduleVars[i];

		НоваяСтрокаМП = ТабПеременных.Добавить();
		НоваяСтрокаМП.Имя = curVar;
		НоваяСтрокаМП.Метод = "Модуль";	
	}
	
	var mMethods = module.context.Methods;
	for(var i=0;i<mMethods.length;i++)
	{
		var Method = mMethods[i];		
		MethodVars = Method._varsTypes;
		var Methodsource = module.getMethodSource(Method.Name);
		for(var key in MethodVars)
		{
			var curVar = key;
			НоваяСтрокаМП = ТабПеременных.Добавить();
			НоваяСтрокаМП.Имя = curVar;
			НоваяСтрокаМП.Метод = Method.Name;
		}
		
		for(j=0;j<Method.Params.length;j++)
		{
			var curVar = Method.Params[j];
			НоваяСтрокаМП = ТабПеременных.Добавить();
			НоваяСтрокаМП.Имя = curVar;
			НоваяСтрокаМП.Метод = Method.Name;
		}
		
	}	
	
	ТабПеременных.Свернуть("Имя, Метод");
	
	return ТабПеременных;
}

function НайтиПохожиеПеременные(Параметры, ТабПеременных)
{
	var ТабПохожих = v8New("ТаблицаЗначений");
	
	for(var i=0;i<ТабПеременных.Колонки.Количество();i++)
		ТабПохожих.Колонки.Добавить(ТабПеременных.Колонки.Получить(i).Имя);
	
	МассивСтрокМетода = ТабПеременных.НайтиСтроки(v8New("Структура", "Метод", Параметры.Метод));
	for(var i=0;i<МассивСтрокМетода.Количество();i++)
	{
		var ТекСтрока = МассивСтрокМетода.Получить(i);
		var similar = ТекСтрока.Имя;
		if(isVarSimilar(Параметры.Имя, similar))
		{
			var НоваяСтрока = ТабПохожих.Добавить();
			НоваяСтрока.Имя = similar;
			НоваяСтрока.Метод = ТекСтрока.Метод;
		}
	}
	
	return ТабПохожих;
}

function ПолучитьНомерСтрокиПеременной(ТекСтрока)
{
	if(ТекСтрока.Параметр1 == "Модуль")
		{
			curLines = Lines
			var StartLine = 0;
		}
		else {
				var curMethod = module.context.getMethodByName(ТекСтрока.Параметр1);
				curLines = module.textWindow.GetLines(curMethod.StartLine, curMethod.EndLine);
				var StartLine = curMethod.StartLine;
			 }
		var re = getRegExpVar(ТекСтрока.ВидПроблемы)	
		for(j=0;j<curLines.length;j++)
		{
			line = curLines[j];
			if(!line || line.match(/^\s*[\|"\|]/))
				continue
			
			if((Matches = re.exec(line)) != null)
				{
				return StartLine + j;
				}
		}

}

CodeAnalysis.prototype.CheckSimilarVars = function(module)
{
	//debugger
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Похожие переменные (возможно ошибки в написании)";
	var Параметр1   = "Контекст";
	var Справка     = "http://its.1c.ru/db/v8std#content:2149184105:1";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	
	var ТабПеременных = ПолучитьСписокВсехПеременных(module);
	for(var i=0;i<ТабПеременных.Количество();i++)
	{
		var ТекСтрока = ТабПеременных.Получить(i)
		var original = ТекСтрока.Имя;
		if(СтрокаВидПроблемы.Строки.Найти(original, "ВидПроблемы", true)!=undefined)
			continue;
		var ТабПохожих = НайтиПохожиеПеременные(ТекСтрока, ТабПеременных);
		if(ТабПохожих.Количество() > 0)
		{
			НоваяСтрока = СтрокаВидПроблемы.Строки.Добавить();
			НоваяСтрока.ВидПроблемы = original;
			НоваяСтрока.Параметр1 = ТекСтрока.Метод;
			НоваяСтрока.НомерСтроки = ПолучитьНомерСтрокиПеременной(НоваяСтрока);
			for(var j=0;j<ТабПохожих.Количество();j++)
			{
				СтрокаПохожих = ТабПохожих.Получить(j);
				НоваяСтрока1 = НоваяСтрока.Строки.Добавить();
				НоваяСтрока1.ВидПроблемы = СтрокаПохожих.Имя;
				НоваяСтрока1.Параметр1 = СтрокаПохожих.Метод;
				НоваяСтрока1.НомерСтроки = ПолучитьНомерСтрокиПеременной(НоваяСтрока1);
			}
			
		}
	}
	
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "НомерСтроки");
}

CodeAnalysis.prototype.CheckDeadVars = function(module)
{
	//debugger
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Объявленные, но не используемые переменные";
	var Параметр1   = "Контекст";
	var Справка     = "http://its.1c.ru/db/v8std#content:2149184105:1";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	var СписокСобытий = СоставитьСписокОбработчиковСобытий();
	
	МертвыеПеременные = v8New("ТаблицаЗначений");
	МертвыеПеременные.Колонки.Добавить("Имя");
	МертвыеПеременные.Колонки.Добавить("Метод");
	
	moduleText = module.textWindow.GetText();
	moduleVars = module.context.ModuleVars;
	Lines = module.textWindow.GetLines();
	for(i=0;i<moduleVars.length;i++)
	{
		var curVar = moduleVars[i];
		ВсегоОбращений = 0;
		re = getRegExpVar(curVar);
		while((Matches = re.exec(moduleText)) != null)
			ВсегоОбращений++;
		if(ВсегоОбращений <=1)
		{
			НоваяСтрокаМП = МертвыеПеременные.Добавить();
			НоваяСтрокаМП.Имя = curVar;
			НоваяСтрокаМП.Метод = "Модуль";
		}
		
	}
	
	var mdObj = module.textWindow.textWindow.mdObj;
	var СтрокаИсключенийПеременных = ИсключенияПеременных(mdObj);
	var СтрокаОбработчиков 		   = this.ПолучитьСтрокуОбработчиков(mdObj);
	
	var mMethods = module.context.Methods;
	for(var i=0;i<mMethods.length;i++)
	{
		var Method = mMethods[i];		
		MethodVars = Method._varsTypes;
		var Methodsource = module.getMethodSource(Method.Name);
		for(var key in MethodVars)
		{
			var curVar = key;
			if(moduleVars.indexOf(curVar)>=0)
				continue
				
			re = getRegExpVarEx(curVar);	
			if((Matches = re.exec(СтрокаИсключенийПеременных)) != null)
				continue
				
			re = getRegExpVarCount(curVar); 
			if((Matches = re.exec(Methodsource)) != null)
				continue
				
			ВсегоОбращений = 0;
			
			re = getRegExpVar(curVar);
			while((Matches = re.exec(Methodsource)) != null)
				ВсегоОбращений++;
			if(ВсегоОбращений <=1)
			{
				НоваяСтрокаМП = МертвыеПеременные.Добавить();
				НоваяСтрокаМП.Имя = curVar;
				НоваяСтрокаМП.Метод = Method.Name;
			}
		}
		
		needContinue = false;
		for(k=0;k<СписокСобытий.length;k++)
		{
			if(Method.Name.indexOf(СписокСобытий[k])>=0)
			{
					needContinue = true;
					break;
			};
		}
		
		if(needContinue)
			continue
			
		for(j=0;j<Method.Params.length;j++)
		{
			var curVar = Method.Params[j];
			re = getRegExpVarEx(curVar);	
			if((Matches = re.exec(СтрокаИсключенийПеременных)) != null)
				continue
				
			re = getRegExpVarEx(Method.Name);	
			if((Matches = re.exec(СтрокаОбработчиков)) != null)
				continue
				
			ВсегоОбращений = 0;
			
			re = getRegExpVar(curVar);
			while((Matches = re.exec(Methodsource)) != null)
				ВсегоОбращений++;
			if(ВсегоОбращений <=1)
			{
				НоваяСтрокаМП = МертвыеПеременные.Добавить();
				НоваяСтрокаМП.Имя = curVar;
				НоваяСтрокаМП.Метод = Method.Name;
			}
		}
		
	}	
	
	for(i=0;i<МертвыеПеременные.Количество();i++)
	{
		ТекСтрока = МертвыеПеременные.Получить(i);
		if(ТекСтрока.Метод == "Модуль")
		{
			curLines = Lines
			var StartLine = 0;
		}
		else 
		{
			var curMethod = module.context.getMethodByName(ТекСтрока.Метод);
			curLines = module.textWindow.GetLines(curMethod.StartLine, curMethod.EndLine);
			var StartLine = curMethod.StartLine;
		 }
			
		re = getRegExpVar(ТекСтрока.Имя)	
		for(j=0;j<curLines.length;j++)
		{
			line = curLines[j];
			if(!line || line.match(/^\s*[\|"\|]/))
				continue		
			if((Matches = re.exec(line)) != null)
				{
				СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
				СтрокаМетода.ВидПроблемы = ТекСтрока.Имя;
				СтрокаМетода.Параметр1   = ТекСтрока.Метод;
				СтрокаМетода.НомерСтроки = StartLine + j;
				break;
				}
		}
	}
		
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1");
}
	
CodeAnalysis.prototype.CheckDeadMethods = function(module)
{
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Объявленные, но не используемые методы";
	var Параметр1   = "";
	var Справка     = "http://its.1c.ru/db/v8std#content:2149184105:1";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	var СписокСобытий = СоставитьСписокОбработчиковСобытий();
	var СтрокаОбработчиков = this.ПолучитьСтрокуОбработчиков(module.textWindow.textWindow.mdObj);
	
	moduleText = module.textWindow.GetText();
	var mMethods = module.context.Methods;
	for(var i=0;i<mMethods.length;i++)
	{
		var Method = mMethods[i];		
			
		if(!isCalls(Method, module, СписокСобытий, СтрокаОбработчиков))
		{
			СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
			СтрокаМетода.ВидПроблемы = Method.Name;
			СтрокаМетода.Параметр1   = "";
			СтрокаМетода.НомерСтроки = Method.StartLine + 1;
		}
	}	
	
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1 Убыв");
}

CodeAnalysis.prototype.CheckOperatorsCount = function(module)
{
	//debugger
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Слишком сложное условие (используйте выделение в переменную или метод)";
	var Параметр1   = "Количество операторов";
	var Справка     = "http://refactoring.guru/decompose-conditional";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	
	var Lines = module.textWindow.GetLines();
	
	var НачалоУсловия = false;
	var КонецУсловия = false;
	var СтрокаУсловия = "";
	re = new RegExp("(\\sИ\\s)|(\\sИЛИ\\s)", 'ig');
	
	for(var i=0;i<Lines.length;i++)
	{
		var line = Lines[i];	
		if(!line)
			continue
		//if(line.match("\\s"//))
		//	continue
		{
			if(line.match("Если\\s(.*)\\sТогда")) // условие в одной строке
			{
				НачалоУсловия = true;
				КонецУсловия = true;
				var НомерСтроки = i;
				СтрокаУсловия = line;
			}
			else
			{
				if((line.match("Если\\s(.*)")) || (line.match("(.*)\\sТогда")))
				{
					if(line.match("Если\\s(.*)"))
					{
						НачалоУсловия = true;
						СтрокаУсловия = line;
						var НомерСтроки = i;
					}
					if(line.match("(.*)\\sТогда"))
					{
						КонецУсловия = true;
						СтрокаУсловия = СтрокаУсловия + line;
					}
				}
				else
					if(НачалоУсловия)
						СтрокаУсловия = СтрокаУсловия + line;	
			}
			
			if(НачалоУсловия && КонецУсловия)
			{
				//Вставить проверку условия
				var ВсегоВхождения = 0;
				while((Matches = re.exec(СтрокаУсловия))!= null)
				{
					ВсегоВхождения++;

				}
				if(ВсегоВхождения>MaxOperatorsCount)
				{
					СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
					СтрокаМетода.ВидПроблемы = СтрокаУсловия;
					СтрокаМетода.Параметр1   = ВсегоВхождения;
					СтрокаМетода.НомерСтроки = НомерСтроки + 1;
				}
				НачалоУсловия = false;
				КонецУсловия  = false;
				СтрокаУсловия = "";
			}
		}		
	}
	
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1 Убыв");
}

CodeAnalysis.prototype.CheckStringSize = function(module)
{
	//debugger
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Слишком длинная строка кода (используйте переносы и выделение переменных)";
	var Параметр1   = "Количество символов";
	var Справка     = "http://its.1c.ru/db/v8std#content:-2145783203:1";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	
	var Lines = module.textWindow.GetLines();
	
	for(var i=0;i<Lines.length;i++)
	{
		var line = Lines[i];		
		if(line.length > MaxStringSize)
		{
			if(line.match(/^\s*[\|]/) && NoUseDevString)
				continue;
			СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
			СтрокаМетода.ВидПроблемы = line;
			СтрокаМетода.Параметр1   = line.length;
			СтрокаМетода.НомерСтроки = i + 1;
		}		
	}
	
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1 Убыв");
}

CodeAnalysis.prototype.CheckParamsCount = function(module)
{
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Метод содержит слишком много параметров (объедините параметры в структуру)";
	var Параметр1   = "Количество параметров";
	var Справка     = "http://its.1c.ru/db/v8std#content:2149184289:1";//"http://refactoring.guru/smells/long-parameter-list";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);

	var mMethods = module.context.Methods;
	for(var i=0;i<mMethods.length;i++)
	{
		var Method = mMethods[i];		
			
		var ParamsCount = this.getParamsCount(Method, module);
		if(ParamsCount > MaxParamsCount){
			СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
			СтрокаМетода.ВидПроблемы = Method.Name;
			СтрокаМетода.Параметр1   = ParamsCount;
			СтрокаМетода.НомерСтроки = Method.StartLine + 1;
		}		
	}
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1 Убыв");
}


CodeAnalysis.prototype.CheckMethodsSize = function(module)
{
	ДеревоАнализаДанных = this.form.ДеревоАнализаДанных;
	var ВидПроблемы = "Метод содержит слишком много строк (разбейте его на отдельные методы)";
	var Параметр1   = "Количество строк";
	var Справка     = "http://refactoring.guru/smells/long-Method";
	
	var СтрокаВидПроблемы = AddProblemString(ДеревоАнализаДанных, ВидПроблемы, Параметр1, Справка);
	
	var mMethods = module.context.Methods;
	for(var i=0;i<mMethods.length;i++)
	{
		var Method = mMethods[i];		
			
		var MethodSize = this.getMethodSize(Method, module);
		if(MethodSize > MaxProcSize){
			СтрокаМетода = СтрокаВидПроблемы.Строки.Добавить();
			СтрокаМетода.ВидПроблемы = Method.Name;
			СтрокаМетода.Параметр1   = MethodSize;
			СтрокаМетода.НомерСтроки = Method.StartLine + 1;
		}		
	}
	SortProblemString(ДеревоАнализаДанных, СтрокаВидПроблемы, "Параметр1 Убыв");
}

CodeAnalysis.prototype.getParamsCount = function (Method, module)
{

	var ЗаголовокМетода = module.textWindow.GetLine(Method.StartLine + 1);
	var VarArr = [];
	re = new RegExp('\\((\\D.*)\\)', 'ig');
	if((Matches = re.exec(ЗаголовокМетода)) != null)
	{
		var str1 = ""+Matches[1];
		if(!str1){}
		else
			VarArr = str1.split(',');
	}

	return VarArr.length;
}

CodeAnalysis.prototype.getMethodSize = function (Method, module)
{
	//По умолчанию считаем все строки метода
	var endline   = Method.EndLine;
	var startline = Method.StartLine;
	
	//Удалим строки с текстом запроса
	if(NoUseQuery || NoUseEmptyLines)
	{
		Lines = module.textWindow.GetLines(Method.StartLine + 2, Method.EndLine);
		for(var i=Lines.length-1;i>=0;i--)
		{
			var line = Lines[i];
			if(NoUseEmptyLines && line == "")
				{
					Lines.splice(i,1);
					continue
				}
			if(NoUseQuery && line.match(/^\s*[\|"]/)) // Строка начинается с | или "
					Lines.splice(i,1);
		}
		startline = 0;
		endline   = Lines.length;
	}

	return endline - startline;
}

CodeAnalysis.prototype.goToLine = function (row)
{

    if (!this.targetWindow)
        return;
    if (!this.targetWindow.IsActive())
    {   
		DoMessageBox("Окно, для которого показывался список, было закрыто!");
        return;
    }
	if (!row.НомерСтроки)
		return;
		
    this.activateEditor();
    var textline = this.targetWindow.GetLine(row.НомерСтроки)
    // Установим выделение на найденное совпадение со строкой поиска.
    this.targetWindow.SetCaretPos(row.НомерСтроки, 1);
	re = getRegExpVar(row.ВидПроблемы);	
	if((Matches = re.exec(textline)) != null)
	{
		this.targetWindow.SetSelection(row.НомерСтроки, Matches.index+2, row.НомерСтроки, Matches.index + row.ВидПроблемы.length + 2);
	}
	else
	{
		//Message("Похоже строка была изменена. Обновите форму анализа");
		ЕстьРеквизит = false;
		if(row.СтрокаКон != undefined)
		{
			var textline = this.targetWindow.GetLine(row.СтрокаКон)
			this.targetWindow.SetSelection(row.НомерСтроки, 1, row.СтрокаКон, textline.length + 1)
		}
		else
			{
				arrstr = row.ВидПроблемы.split("\n");
				var textline = this.targetWindow.GetLine(row.НомерСтроки + arrstr.length - 1)
				this.targetWindow.SetSelection(row.НомерСтроки, 1, row.НомерСтроки + arrstr.length - 1, textline.length + 1);
			}
	}

}


////////////////////////////////////////////////////////////////33////////////////////////
////{ TextWindowsWatcher - отслеживает активизацию текстовых окон и запоминает последнее.
////

function TextWindowsWatcher() {
    this.timerId = 0;
    this.lastActiveTextWindow = null;
    this.startWatch();
}

TextWindowsWatcher.prototype.getActiveTextWindow = function () {
    if (this.lastActiveTextWindow && this.lastActiveTextWindow.IsActive())
        return this.lastActiveTextWindow;
    return null;
}

TextWindowsWatcher.prototype.startWatch = function () {
    if (this.timerId)
        this.stopWatch();
    //this.timerId = createTimer(500, this, 'onTimer');
}

TextWindowsWatcher.prototype.stopWatch = function () {
    if (!this.timerId)
        return;
    killTimer(this.timerId);
    this.timerId = 0;
}

TextWindowsWatcher.prototype.onTimer = function (timerId)
{
    var wnd = GetTextWindow();    
    if (wnd){
		if (this.lastActiveTextWindow){
			if (wnd.textWindow.textMgr != this.lastActiveTextWindow.textWindow.textMgr)
			this.lastActiveTextWindow = wnd;}
		else this.lastActiveTextWindow = wnd;
	}
    else 
		if (this.lastActiveTextWindow && !this.lastActiveTextWindow.IsActive())
			this.lastActiveTextWindow = null;
}
//} TextWindowsWatcher

//////////////////
//{ Форма настроек
////
function ОКНажатие(Элемент) 
{
	мЗаписатьНастройки()
    мФормаНастройки.Закрыть()
}

function ОтменаНажатие(Элемент) 
{
	мФормаНастройки.Закрыть()
}

CodeAnalysis.prototype.КоманднаяПанель1Настройки = function(Элемент) 
{
    var pathToForm=SelfScript.fullPath.replace(/.js$/, 'param.ssf')
    мФормаНастройки=loadScriptForm(pathToForm, SelfScript.self)
    мФормаНастройки.ОткрытьМодально()
}

function мЗаписатьНастройки()
{
    MaxProcSize 	  = мФормаНастройки.МаксимальныйРазмерМетода;
	NoUseQuery        = мФормаНастройки.НеУчитыватьТекстЗапроса;
	NoUseEmptyLines   = мФормаНастройки.НеУчитыватьПустыеСтроки;
	MaxParamsCount 	  = мФормаНастройки.МаксимальноеКоличествоПараметров;
	MaxStringSize 	  = мФормаНастройки.МаксимальныйРазмерСтроки;
	NoUseDevString 	  = мФормаНастройки.НеУчитыватьСтрокиСПереносом;
	MaxOperatorsCount = мФормаНастройки.МаксимальноеКоличествоОператоров;
	DupBlockMin 	  = мФормаНастройки.МинимальныйРазмерБлока;
	DupBlockMax 	  = мФормаНастройки.МаксимальныйРазмерБлока;
	
    profileRoot.setValue(pflCodeAnalysisMaxProcSize, 	   MaxProcSize)	
	profileRoot.setValue(pflCodeAnalysisNoUseQuery,  	   NoUseQuery)
	profileRoot.setValue(pflCodeAnalysisNoUseEmptyLines,   NoUseEmptyLines)
	profileRoot.setValue(pflCodeAnalysisMaxParamsCount,    MaxParamsCount)
	profileRoot.setValue(pflCodeAnalysisMaxStringSize,     MaxStringSize)
	profileRoot.setValue(pflCodeAnalysisNoUseDevString,    NoUseDevString)
	profileRoot.setValue(pflCodeAnalysisMaxOperatorsCount, MaxOperatorsCount)
	profileRoot.setValue(pflCodeAnalysisDupBlockMin, 	   DupBlockMin)
	profileRoot.setValue(pflCodeAnalysisDupBlockMax, 	   DupBlockMax)
}

function НастройкиПриОткрытии() 
{
    мФормаНастройки.МаксимальныйРазмерМетода 		 = MaxProcSize;
	мФормаНастройки.НеУчитыватьТекстЗапроса  		 = NoUseQuery;
	мФормаНастройки.НеУчитыватьПустыеСтроки  		 = NoUseEmptyLines;
	мФормаНастройки.МаксимальноеКоличествоПараметров = MaxParamsCount;
	мФормаНастройки.МаксимальныйРазмерСтроки  		 = MaxStringSize;
	мФормаНастройки.НеУчитыватьСтрокиСПереносом 	 = NoUseDevString;
	мФормаНастройки.МаксимальноеКоличествоОператоров = MaxOperatorsCount;
	мФормаНастройки.МинимальныйРазмерБлока           = DupBlockMin;
	мФормаНастройки.МаксимальныйРазмерБлока          = DupBlockMax;
}
//}

////////////////////////////////////////////////////////////////////////////////////////
////{ Инициализация скрипта
////
var pflCodeAnalysisMaxProcSize       = "CodeAnalysis/MaxProcSize"
var pflCodeAnalysisNoUseQuery        = "CodeAnalysis/NoUseQuery"
var pflCodeAnalysisNoUseEmptyLines   = "CodeAnalysis/NoUseEmptyLines"
var pflCodeAnalysisMaxParamsCount    = "CodeAnalysis/MaxParamsCount"
var pflCodeAnalysisMaxStringSize     = "CodeAnalysis/MaxStringSize"
var pflCodeAnalysisNoUseDevString    = "CodeAnalysis/NoUseDevString"
var pflCodeAnalysisMaxOperatorsCount = "CodeAnalysis/MaxOperatorsCount"
var pflCodeAnalysisDupBlockMin       = "CodeAnalysis/DupBlockMin"
var pflCodeAnalysisDupBlockMax 		 = "CodeAnalysis/DupBlockMax"

// Восстановим настройки
profileRoot.createValue(pflCodeAnalysisMaxProcSize, 	  100,   pflSnegopat)
profileRoot.createValue(pflCodeAnalysisNoUseQuery,  	  true,  pflSnegopat)
profileRoot.createValue(pflCodeAnalysisNoUseEmptyLines,   false, pflSnegopat)
profileRoot.createValue(pflCodeAnalysisMaxParamsCount,    4,     pflSnegopat)
profileRoot.createValue(pflCodeAnalysisMaxStringSize,     120,   pflSnegopat)
profileRoot.createValue(pflCodeAnalysisNoUseDevString,    true,  pflSnegopat)
profileRoot.createValue(pflCodeAnalysisMaxOperatorsCount, 4,     pflSnegopat)
profileRoot.createValue(pflCodeAnalysisDupBlockMin, 	  4,     pflSnegopat)
profileRoot.createValue(pflCodeAnalysisDupBlockMax, 	  30,    pflSnegopat)

var мФормаНастройки = null
var MaxProcSize = profileRoot.getValue(pflCodeAnalysisMaxProcSize)
var NoUseQuery = profileRoot.getValue(pflCodeAnalysisNoUseQuery)
var NoUseEmptyLines = profileRoot.getValue(pflCodeAnalysisNoUseEmptyLines)
var MaxParamsCount = profileRoot.getValue(pflCodeAnalysisMaxParamsCount)
var MaxStringSize = profileRoot.getValue(pflCodeAnalysisMaxStringSize)
var NoUseDevString = profileRoot.getValue(pflCodeAnalysisNoUseDevString)
var MaxOperatorsCount = profileRoot.getValue(pflCodeAnalysisMaxOperatorsCount)
var DupBlockMin = profileRoot.getValue(pflCodeAnalysisDupBlockMin)
var DupBlockMax = profileRoot.getValue(pflCodeAnalysisDupBlockMax)
//}